#include "SendRecvThread.h"
#include "MySyncObject.h"		// CMySyncObjectg
#include "RingBuff.h"			// CRingBuffg
#include "SendFileThread.h"		// CSendFileThreadg

// Mx
#define		SEND_BPS	(1000000.0)	// Mx1Mbps

//----------------------------------------------
// function
//    RXgN^
// parameter
//    ConnectionInfoRec *pConInfo	[in]@\ɕKvȏ
// return
//    Ȃ
//----------------------------------------------
CSendRecvThread::CSendRecvThread(ConnectionInfoRec *pConInfo)
{
	m_pConInfo = pConInfo;
	m_fIamZombie = FALSE;
	m_pCRingBuffSend = new CRingBuff(SEND_BUFF_SIZE);	// MOobt@̍\z
	m_pCRingBuffRecv = new CRingBuff(RECV_BUFF_SIZE);	// MOobt@̍\z

	m_dwPrevSentTime = 0;						// 񑗐M͂
	m_dwSendInterval = 0;						// 
	m_pCSendFileThread = NULL;					// t@CM{Xbh
}


//----------------------------------------------
// function
//    fXgN^
// parameter
//    Ȃ
// return
//    Ȃ
//----------------------------------------------
CSendRecvThread::~CSendRecvThread()
{
	if (m_pCSendFileThread != NULL)		// Ă~߂(fKvł傤)
	{
		m_pCSendFileThread->End();
		m_pCSendFileThread->WaitForEnd();
	}
	SAFE_DELETE(m_pCSendFileThread)

	SAFE_DELETE(m_pCRingBuffSend)		// MOobt@̔j
	SAFE_DELETE(m_pCRingBuffRecv)		// MOobt@̔j
}

//----------------------------------------------
// function
//    @\Lq֐(DoSend, DoRecv̓eLq)
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
UINT CSendRecvThread::DoWork()
{
	BOOL		fRet = TRUE;
	fd_set      wfds, rfds;
	struct timeval   tv;
	char		*pcData = NULL;				// Mf[^
	int			iSendSize = 0;				// Mf[^TCY
	char	    szRecvBuffer[RCVBUFSIZE];	// Mf[^ꎞIɊi[
	int			iRecvSize;
	DWORD		dwNow;						// M`FbNo邽

	while (!m_fStopFlag)
	{
		KillSendFileThread();				// t@CMIĂXbhj

		tv.tv_sec = 0;
		tv.tv_usec = 10 * 1000;				// 10msec
		FD_ZERO(&rfds);
		FD_ZERO(&wfds);
		// Mf[^pfd_set͏ɃZbg
		FD_SET(m_pConInfo->fdClient, &rfds);
		// M\Mf[^ƂM\pfd_setɃZbg
		// Mf[^邩Oobt@𒲂ׂ
		iSendSize = m_pCRingBuffSend->GetReadableSize();
		// `FbN̂߂Ɍݎ擾
		timeBeginPeriod(1);					// ^C}[̍ŏx1msecɂ
		dwNow = timeGetTime();
		timeEndPeriod(1);					// ^C}[̍ŏx߂
		// M\Mf[^邩
		if ((iSendSize > 0) && (CanSendNow(dwNow) == TRUE))
			FD_SET(m_pConInfo->fdClient, &wfds);

		select(FD_SETSIZE, &rfds, &wfds, NULL, &tv);	// ^CAEg܂SleepƓ
		// M(DoRecv)
		if (FD_ISSET(m_pConInfo->fdClient, &rfds))		// Mf[^recv{
		{
			// MOobt@ɋ󂫂Ύ擾
			// ŎMȂ΁AFD_ISSETŎMf[^肪Zbĝ
			// Ɏ擾邱Ƃł
			iRecvSize = min(m_pCRingBuffRecv->GetWriteableSize(), RCVBUFSIZE);
			if (iRecvSize > 0)
			{
				if ((iRecvSize = recv(m_pConInfo->fdClient, szRecvBuffer, iRecvSize, 0)) <= 0)
				{
					m_pConInfo->pCMySyncObject->Lock();
					if (iRecvSize == 0)
						DispErrorMsg("Disconnected recv");
					else
						DispErrorMsg("Err:recv");
					m_pConInfo->pCMySyncObject->UnLock();
					fRet = FALSE;
					break;
				}
				else
				{
					// 擾f[^ɎMOobt@ɏ
					// MOobt@ɏނ̂͂̃XbhȂ̂ŁAׂď߂͂
					m_pCRingBuffRecv->Write((LPBYTE)szRecvBuffer, iRecvSize);
				}
			}
		}
		// MOobt@Ɋi[Ăf[^̉͂s
		// ̃pPbgi[Ă\̂ŁAFD_ISSEŤʂƂ͖֌W
		// ͂s悤ɂ
		if (AnalyzeDataRecv() == -1)					// Ԓl-1̎G[
		{
			m_pConInfo->pCMySyncObject->Lock();
			DispErrorMsg("Err:Packet format");
			m_pConInfo->pCMySyncObject->UnLock();
			fRet = FALSE;
			break;
		}
		// M(DoSend)
		if (FD_ISSET(m_pConInfo->fdClient, &wfds))		// M\Ȃsend{
		{
			// Mf[^̎擾(PATH_MTU菬Ȃ悤Ɏ擾)
			iSendSize = GetSendData(&pcData);
			if (send(m_pConInfo->fdClient, pcData, iSendSize, 0) != iSendSize)
			{
				DispErrorMsg("Err:send\n");
				fRet = FALSE;
				break;
			}
			SAFE_FREE(pcData)
			// MƎ񑗐M܂ł̎ԂZbg
			m_dwPrevSentTime = dwNow;
			m_dwSendInterval = CalcNextSendInterval(iSendSize);
		}
	}
	m_pConInfo->pCMySyncObject->Lock();
	m_fIamZombie = TRUE;
	m_pConInfo->pCMySyncObject->UnLock();
	SAFE_FREE(pcData)
	return((fRet == TRUE) ? 0 : -1);
}

//----------------------------------------------
// function
//		Mf[^̐ݒ
// parameter
//		char	*pcData	[in]Mf[^
//		int		iSize	[in]f[^
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SetSendData(char *pcData, int iSize)
{
	BOOL	fRet = FALSE;

	// MOobt@ɋ󂫂ȂƂ͏܂Ȃ
	fRet = m_pCRingBuffSend->Write((LPBYTE)pcData, iSize);
	return(fRet);
}

//----------------------------------------------
// function
//		Mf[^̎擾
// parameter
//		char **ppcData	[in/out]Mf[^
// return
//		f[^
//----------------------------------------------
int CSendRecvThread::GetSendData(char **ppcData)
{
	int		iSize = 0;

	// Mf[^邩Oobt@̃f[^TCY𒲂ׂ
	if ((iSize = m_pCRingBuffSend->GetReadableSize()) > 0)
	{
		// MTCYPATH_MTU菬Ă(1024+ʃwb_Ȃv)
		iSize = min(iSize, SENDBUFSIZE);
		*ppcData = (char *)calloc(iSize, sizeof(char));
		iSize = m_pCRingBuffSend->Read((LPBYTE)*ppcData, iSize);
	}
	return(iSize);
}

//----------------------------------------------
// function
//    ̃Xbh̓]rԂ
//	  ʃXbhQƂ
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
BOOL CSendRecvThread::IsZombie()
{
	BOOL	fRet;

	m_pConInfo->pCMySyncObject->Lock();
	fRet = m_fIamZombie;
	m_pConInfo->pCMySyncObject->UnLock();
	return(fRet);
}

//----------------------------------------------
// function
//		Mf[^̉
//		MOobt@Ɋi[Ăf[^𒲂ׂ
// parameter
//		Ȃ
// return
//		0:pPbgĂȂ
//		1:pPbgM̂ŏs
//		-1:G[
//----------------------------------------------
int CSendRecvThread::AnalyzeDataRecv()
{
	int			iRet = 0;
	HeaderRec	Header;
	WORD		wCmd;
	// f[^TCY𒲂ׂ
	int			iSize = m_pCRingBuffRecv->GetReadableSize();

	if (iSize < sizeof(HeaderRec))			// wb_TCYɖȂƂ͉Ȃ
		goto L_END;
	// wb_؂ǂݍ݂
	m_pCRingBuffRecv->ReadWithoutUpdateHeadPoint((LPBYTE)&Header, sizeof(HeaderRec));
	// wb_̉
	if (memcmp(Header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING)) != 0)
	{
		iRet = -1;							// ʎqႤ̂ŃG[
		goto L_END;
	}
	wCmd = ntohs(Header.wCommand);
	fprintf(stderr, "CMD:%d\n", wCmd);

	switch (wCmd)
	{
		case CMD_MSG_DATA:
			iRet = RecvMessagePacket(&Header);
			break;
		default:							// mȂR}hȂ̂ŃG[
			iRet = -1;
			break;
	}
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		bZ[WR}h̎M
// parameter
//		HeaderRec *pHeader	[in]ǂ݂wb_
// return
//		0:pPbgĂȂ
//		1:pPbgM̂ŏs
//		-1:G[
//----------------------------------------------
int CSendRecvThread::RecvMessagePacket(HeaderRec *pHeader)
{
	int			iRet = 0;
	MsgDataRec	*pMsgData = NULL;
	int			iMsgSize, iSize;
	char		*pszMsg = NULL;
	LPBYTE		pbDest = NULL;

	iMsgSize = ntohs(pHeader->wDataLen);
	// f[^ȂƂ͉Ȃ
	iSize = m_pCRingBuffRecv->GetReadableSize();
	if (iSize < iMsgSize + sizeof(HeaderRec))
		goto L_END;
	// pPbgŜMĂ̂œǂݍ݂{
	pMsgData = (MsgDataRec *)calloc(iMsgSize + sizeof(HeaderRec), sizeof(BYTE));
	m_pCRingBuffRecv->Read((LPBYTE)pMsgData, iMsgSize + sizeof(HeaderRec));
	// NULL^[~l[gǉĊm
	pszMsg = (char *)calloc(iMsgSize + 1, sizeof(char));
	memcpy(pszMsg, pMsgData->bMsgData, iMsgSize);

	// UTF-8ŎM̂ŁASJISɕϊĕ\
	ConvUtf8toSJis((LPBYTE)pszMsg, NULL, &iSize);
	pbDest = (LPBYTE)calloc(iSize, sizeof(BYTE));
	ConvUtf8toSJis((LPBYTE)pszMsg, pbDest, &iSize);
	m_pConInfo->pCMySyncObject->Lock();
	fprintf(stderr, "Msg:recv %s\n", pbDest);
	m_pConInfo->pCMySyncObject->UnLock();
	SAFE_FREE(pMsgData)
	SAFE_FREE(pbDest)
	SAFE_FREE(pszMsg)
	iRet = 1;
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		̑M܂ł̊Ԋu(msec)߂
// parameter
//		Ȃ
// return
//		msec
//----------------------------------------------
DWORD CSendRecvThread::CalcNextSendInterval(int iSentSize)
{
	DWORD	dwInterval = 0;
	double	dbBytePerSec = SEND_BPS / 8.0;
	double	dbCountPerSec;

	if (iSentSize == 0)
		goto L_END;
	dbCountPerSec = dbBytePerSec / (double)iSentSize;
	dwInterval = DWORD(1000.0 / dbCountPerSec);

L_END:
	return(dwInterval);
}


//----------------------------------------------
// function
//		M\
// parameter
//		DWORD dwNow		[in]ݎ
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::CanSendNow(DWORD dwNow)
{
	BOOL	fRet = FALSE;

	if (GetdwInterval(dwNow, m_dwPrevSentTime) >= m_dwSendInterval)
		fRet = TRUE;

	return(fRet);
}

//----------------------------------------------
// function
//		t@CM̎{
// parameter
//		LPSTR	pszFileName	[in]t@C
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SendFile(LPSTR pszFileName)
{
	BOOL		fRet = FALSE;

	// t@CMXbhLȎ(M)͑MJnȂ
	if (m_pCSendFileThread != NULL)
	{
		fprintf(stderr, "t@CM@t@CM܂ő҂Ă\n");
		goto L_END;
	}
	m_pCSendFileThread = new CSendFileThread(this, pszFileName);
	m_pCSendFileThread->Begin();
	fRet = TRUE;
L_END:
	return(fRet);
}

//----------------------------------------------
// function
//		t@CMς݂CSendFileThreadj
// parameter
//		Ȃ
// return
//		TRUE:j/FALSE:ĵׂȂ
//----------------------------------------------
BOOL CSendRecvThread::KillSendFileThread()
{
	BOOL	fRet = FALSE;

	if (m_pCSendFileThread != NULL)
	{
		if (m_pCSendFileThread->IsZombie() == TRUE)
		{
			m_pCSendFileThread->End();
			m_pCSendFileThread->WaitForEnd();
			SAFE_DELETE(m_pCSendFileThread)
			fRet = TRUE;
		}
	}
	return(fRet);
}
